# NDVI using Map Algebra syntax v. 1

# Created by:  Nathan Jennings
# Created on: 02.02.2011
# Updated on: 02.02.2011

'''
This algorithm mimics the functionality of NDVI(Normalized Difference Vegetation Index)
as per the scaling factor found in the Image Analysis Window and NDVI functions and
ArcGIS Help.

Rouse, J. W., Haas, R. H., Schell, J. A. and D. W. Deering, 1974, "Monitoring
Vegetation Systems in the Great Plains with ERTS, Proceedings, 3rd Earth
Resource Technology Satellite (ERTS) Symposium, Vol. 1, 48-62.

ERTS became the Landsat Program.

Supports ArcGIS 10 and Python 2.6.5
Requires Spatial Analyst Extension

NOTE:  This version does not do any data clean up.  Users will need to delete data from
disk manually when using this algorithm more than one time.

Change the data path as needed.

'''

# Import arcpy and Spatial Analyst modules
import arcpy
from arcpy.sa import *

# change this path as needed for own data
# !!!!!!!  This workspace path will likely need to be modified to run correctly !!!!!
arcpy.env.workspace = 'c:\\GTCM\\3 - Sensor Platforms_Image Processing Basics_Band Ratios\\Data\\'

# Check out the Spatial Analysis Extension
arcpy.CheckOutExtension("spatial")


# Variables

#b3 = 'tm_sacsub3.tif'
#b4 = 'tm_sacsub4.tif'

b3 = 'tm_sacsub.img\\Layer_3'  # Band 3 (Red) from tm_sacsub.img file
b4 = 'tm_sacsub.img\\Layer_4'  # Band 4 (IR)

# !!!!!!!  This workspace path will likely need to be modified to run correctly !!!!!
out_img = "C:\\temp\\NDVI_Python.img"

# This is what comes out of the Model Builder when the code is exported from Model Builder
# Syntax is not useable coming out of Model Builder.

#arcpy.gp.RasterCalculator_sa("(Float((\"%tm_sacsub.img - Layer_4 (3)%\" - \"%tm_sacsub.img - Layer_3 (3)%\")) /Float( (\"%tm_sacsub.img - Layer_4 (3)%\" + \"%tm_sacsub.img - Layer_3 (3)%\"))*100) + 100", NDVI_RC_MB3_img)

print 'starting'
# This did not work either

#outfloat = Float((b4 - b3) / (b4 + b3)) * 100 + 100
# NDVI as per ESRI


# Raster Data needs to be converted to floating point image for the algorithm
# to comput correctly
# * 100 and + 100 are scale factors.  Alternatively, the Min-Max range of the bands can
# be used for scaling the data.

outfloat = Float((Raster(b4) - Raster(b3))) / Float((Raster(b4) + Raster(b3))) * 100 + 100
outfloat.save(out_img)

# This didn't work either.  Still trying to determine if RasterCalculator like this
# is supported in Python.  I don't think so.

#arcpy.gp.RasterCalculator_sa((Float((b4 - b3) / (b4 + b3)) * 100) + 100, out_img)
print 'completed'
